package com.glxp.api.admin.dao.basic;

import com.glxp.api.admin.entity.basic.UdiInfoEntity;
import com.glxp.api.admin.req.basic.FilterUdiInfoRequest;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

@Mapper
public interface UdiInfoDao {

    List<UdiInfoEntity> filterUdiInfo(FilterUdiInfoRequest filterUdiInfoRequest);

    UdiInfoEntity findByNameCode(@Param("nameCode") String nameCode);

    UdiInfoEntity findByUuid(@Param("uuid") String uuid);

    List<UdiInfoEntity> findByUuids(@Param("uuid") String uuid);

    boolean insertUdiInfo(UdiInfoEntity udiInfoEntity);

    boolean insertUdiInfos(@Param("udiInfoEntities") List<UdiInfoEntity> udiInfoEntities);

    boolean updateUdiInfo(UdiInfoEntity udiInfoEntity);

    boolean deleteById(@Param("id") String id);

    boolean deleteByUuid(@Param("uuid") String uuid);

    /**
     * 根据UUID批量查询数据
     *
     * @param uuids
     * @return
     */
    List<UdiInfoEntity> batchSelectByUuid(@Param("uuids") List<String> uuids);

    /**
     * 导入医疗器械信息
     *
     * @param udiInfoEntities
     */
    void importUdiInfo(@Param("udiInfoEntities") List<UdiInfoEntity> udiInfoEntities);

}
