package com.glxp.api.admin.service.basic.impl;

import com.github.pagehelper.PageHelper;
import com.glxp.api.admin.dao.basic.BussinessOriginTypeDao;
import com.glxp.api.admin.entity.basic.BasicThirdSysDetailEntity;
import com.glxp.api.admin.entity.basic.BussinessOriginTypeEntity;
import com.glxp.api.admin.req.basic.BussinessOriginTypeFilterRequest;
import com.glxp.api.admin.res.basic.BussinessOriginTypeResponse;
import com.glxp.api.admin.service.basic.BasicThirdSysDetailService;
import com.glxp.api.admin.service.basic.BussinessOriginTypeService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Collections;
import java.util.List;

@Service
public class BussinessOriginTypeServiceImpl implements BussinessOriginTypeService {

    @Resource
    BussinessOriginTypeDao bussinessOriginTypeDao;
    @Resource
    BasicThirdSysDetailService basicThirdSysDetailService;

    @Override
    public BussinessOriginTypeEntity findByAction(String action) {
        BussinessOriginTypeFilterRequest bussinessOriginTypeFilterRequest = new BussinessOriginTypeFilterRequest();
        bussinessOriginTypeFilterRequest.setAction(action);
        List<BussinessOriginTypeEntity> bussinessOriginTypeEntities = filterList(bussinessOriginTypeFilterRequest);
        if (bussinessOriginTypeEntities != null && bussinessOriginTypeEntities.size() > 0)
            return bussinessOriginTypeEntities.get(0);
        return null;
    }

    @Override
    public BasicThirdSysDetailEntity findSysByAction(String action, String key) {
        BussinessOriginTypeEntity bussinessOriginTypeEntity = findByAction(action);
        if (bussinessOriginTypeEntity != null) {
            BasicThirdSysDetailEntity basicThirdSysDetailEntity = basicThirdSysDetailService.selectByKey(key, bussinessOriginTypeEntity.getThirdSys());
//        basicThirdSysDetailEntity.setLocalAction(bussinessTypResponse.getLocalAction());
            return basicThirdSysDetailEntity;
        }

        return null;
    }

    @Override
    public List<BussinessOriginTypeEntity> filterEnableList(BussinessOriginTypeFilterRequest bussinessOriginTypeFilterRequest) {
        return bussinessOriginTypeDao.filterEnableList(bussinessOriginTypeFilterRequest);
    }

    @Override
    public BussinessOriginTypeResponse finAllByAction(String action) {
        BussinessOriginTypeFilterRequest bussinessOriginTypeFilterRequest = new BussinessOriginTypeFilterRequest();
        bussinessOriginTypeFilterRequest.setAction(action);
        List<BussinessOriginTypeResponse> bussinessOriginTypeEntities = bussinessOriginTypeDao.filterJoinList(bussinessOriginTypeFilterRequest);
        if (bussinessOriginTypeEntities != null && bussinessOriginTypeEntities.size() > 0) {
            return bussinessOriginTypeEntities.get(0);
        }
        return null;
    }

    @Override
    public List<BussinessOriginTypeEntity> filterList(BussinessOriginTypeFilterRequest bussinessOriginTypeFilterRequest) {
        if (bussinessOriginTypeFilterRequest == null) {
            return Collections.emptyList();
        }
        if (bussinessOriginTypeFilterRequest.getPage() != null) {
            int offset = (bussinessOriginTypeFilterRequest.getPage() - 1) * bussinessOriginTypeFilterRequest.getLimit();
            PageHelper.offsetPage(offset, bussinessOriginTypeFilterRequest.getLimit());
        }
        List<BussinessOriginTypeEntity> data = bussinessOriginTypeDao.filterList(bussinessOriginTypeFilterRequest);
        return data;
    }

    @Override
    public boolean updateBusOriginType(BussinessOriginTypeEntity bussinessTypeEntity) {
        return bussinessOriginTypeDao.updateBusOriginType(bussinessTypeEntity);
    }

    @Override
    public boolean insertBusOriginType(BussinessOriginTypeEntity bussinessTypeEntity) {
        return bussinessOriginTypeDao.insertBusOriginType(bussinessTypeEntity);
    }
}
